#include "quadcopter_loop_functions.h"
#include <argos3/core/simulator/simulator.h>
#include <argos3/core/utility/configuration/argos_configuration.h>
#include <argos3/plugins/robots/foot-bot/simulator/footbot_entity.h>
#include <argos3/plugins/robots/eye-bot/simulator/eyebot_entity.h>
#include <controllers/quadcopter/quadcopter.h>

/****************************************/
/****************************************/

Real ArenaX;
Real ArenaY;
Real Arenaz;

int rowy; 
int rowx;
int sub_boxx = 10;
int sub_boxy = 10;

extern CQuadcopterLoopFunctions cLoop;

CQuadcopterLoopFunctions::Trailphe::Trailphe() :
LocationX(1.0f),
LocationY(2.0f),
phe(3.0) {}

void CQuadcopterLoopFunctions::Trailphe::Reset() {

LocationX = 0.0f;
LocationY = 0.0f;
phe = 0.0;
  
}
/****************************************/
/****************************************/

CQuadcopterLoopFunctions::CQuadcopterLoopFunctions() :
   /*
   m_cForagingArenaSideX(NULL),
   m_cForagingArenaSideY(NULL),
   */
   m_workingX(0.0, 0.1f),
   m_workingY(0.0, 0.1f),
   m_CArenasizeX(-30.0f, 30.0f),
   m_CArenasizeY(-30.0f, 30.0f),
   m_pcFloor(NULL),
   m_pcRNG(NULL),
   m_pcRNGCrashSite(NULL),
   m_unCollectedFood(0),
   m_nEnergy(0),
   m_unEnergyPerWalkingRobot(1) {	
}


/****************************************/
/****************************************/

void CQuadcopterLoopFunctions::Init(TConfigurationNode& t_node) {
   try {
      TConfigurationNode& tForaging = GetNode(t_node, "foraging");
      /* Get a pointer to the floor entity */
      m_pcFloor = &GetSpace().GetFloorEntity();
      /* Get the number of food items we want to be scattered from XML */
      UInt32 unFoodItems;
      GetNodeAttribute(tForaging, "items", unFoodItems);
      /* Get the number of food items we want to be scattered from XML */

      GetNodeAttribute(tForaging, "radius", m_fFoodSquareRadius);
       m_fFoodSquareRadius *= m_fFoodSquareRadius; 
      
      /* Create a New RNG for Crashsite Location 
     
       Real ArenaSizeY;
       
       
       GetNodeAttribute(tForaging, "ArenaY", ArenaSizeX);
       
       
       m_CArenasizeY= CVector2((ArenaSizeY/-2.0f)+ 20.0f, (ArenaSizeY/2.0f)- 20.0f);
        */
      
        Real ArenaSizeY;
        Real ArenaSizeX;
	
	GetNodeAttribute(tForaging, "ArenaX", ArenaSizeX);
	GetNodeAttribute(tForaging, "ArenaY", ArenaSizeY);
	  
       m_CArenasizeX1= ArenaSizeX/-2.0f + 20.0f;
       m_CArenasizeX2= m_CArenasizeX1*-1.0f;
       m_workingX= CRange<Real>(m_CArenasizeX1, m_CArenasizeX2);
       
       m_CArenasizeY1= ArenaSizeY/-2.0f + 20.0f;
       m_CArenasizeY2= m_CArenasizeY1*-1.0f;
       m_workingY= CRange<Real>(m_CArenasizeY1, m_CArenasizeY2);

       m_pcRNGCrashSite = CRandom::CreateRNG("argos");
       m_CArenasizeX1 = m_pcRNGCrashSite->Uniform(m_workingX);
       m_CArenasizeX2 = m_CArenasizeX1 +20.0f;
       m_CArenasizeY1 = m_pcRNGCrashSite->Uniform(m_workingY);
       m_CArenasizeY2 = m_CArenasizeY1 +20.0f;
       
       m_cForagingArenaSideX= CRange<Real>(m_CArenasizeX1, m_CArenasizeX2);
       m_cForagingArenaSideY= CRange<Real>(m_CArenasizeY1, m_CArenasizeY2);
       
      trailphe.LocationY=123.0f;
      trailphe.LocationX=124.0f;
      trailphe.phe=6.0;
     

       
      /* Create a new RNG */
      m_pcRNG = CRandom::CreateRNG("argos");
      /* Distribute uniformly the items in the environment */
      for(UInt32 i = 0; i < unFoodItems; ++i) {
         m_cFoodPos.push_back(
            CVector2(m_pcRNG->Uniform(m_cForagingArenaSideX),
                     m_pcRNG->Uniform(m_cForagingArenaSideY)));
      }
/************************************************************************/


       
/**********************************************************************/
      
      /* Get the output file name from XML */
      GetNodeAttribute(tForaging, "output", m_strOutput);
      /* Open the file, erasing its contents */
      m_cOutput.open(m_strOutput.c_str(), std::ios_base::trunc | std::ios_base::out);
      m_cOutput << "# clock\twalking\tresting\tcollected_food\tenergy" << std::endl;
      /* Get energy gain per item collected */
      GetNodeAttribute(tForaging, "energy_per_robot", m_nEnergy);
      /* Get energy loss per walking robot */
      GetNodeAttribute(tForaging, "energy_per_walking_robot", m_unEnergyPerWalkingRobot);
   }
   catch(CARGoSException& ex) {
      THROW_ARGOSEXCEPTION_NESTED("Error parsing loop functions!", ex);
   }
}

/****************************************/
/****************************************/

void CQuadcopterLoopFunctions::Reset() {
   /* Zero the counters */
   m_unCollectedFood = 0;
   m_nEnergy = 0;
   /* Close the file */
   m_cOutput.close();
   /* Open the file, erasing its contents */
   m_cOutput.open(m_strOutput.c_str(), std::ios_base::trunc | std::ios_base::out);
   m_cOutput << "# clock\twalking\tresting\tcollected_food\tenergy" << std::endl;
   
   
     
       m_CArenasizeX1 = m_pcRNGCrashSite->Uniform(m_workingX);
       m_CArenasizeX2 = m_CArenasizeX1 +20.0f;
       m_CArenasizeY1 = m_pcRNGCrashSite->Uniform(m_workingY);
       m_CArenasizeY2 = m_CArenasizeY1 +20.0f;
       
       m_cForagingArenaSideX= CRange<Real>(m_CArenasizeX1, m_CArenasizeX2);
       m_cForagingArenaSideY= CRange<Real>(m_CArenasizeY1, m_CArenasizeY2);
   
   /* Distribute uniformly the items in the environment */
   for(UInt32 i = 0; i < m_cFoodPos.size(); ++i) {
    
     
      m_cFoodPos[i].Set(m_pcRNG->Uniform(m_cForagingArenaSideX),
                        m_pcRNG->Uniform(m_cForagingArenaSideY));
   }
}

/****************************************/
/****************************************/

void CQuadcopterLoopFunctions::Destroy() {
   /* Close the file */
   m_cOutput.close();
}

/****************************************/
/****************************************/

CColor CQuadcopterLoopFunctions::GetFloorColor(const CVector2& c_position_on_plane) {
   if(c_position_on_plane.GetX() < -70.0f && c_position_on_plane.GetY() < -70.0f) {
      return CColor::GRAY50;
   }
    for(UInt32 i = 0; i < m_cFoodPos.size(); ++i) {
      if((c_position_on_plane - m_cFoodPos[i]).SquareLength() < m_fFoodSquareRadius) {
         return CColor::YELLOW;
      } 
   }
   
   return CColor::BLUE;
}

/****************************************/
/****************************************/


void CQuadcopterLoopFunctions::PreStep() {
  UInt32 unWalkingQBs = 0;
  UInt32 unRestingQBs = 0;
  
  CSpace::TMapPerType& m_cQuadbots = GetSpace().GetEntitiesByType("eye-bot");
  
     for(CSpace::TMapPerType::iterator it = m_cQuadbots.begin();
       it != m_cQuadbots.end();
       ++it) {
       
;       /* Get handle to foot-bot entity and controller */
     
     CEyeBotEntity& cQuadbots = *any_cast<CEyeBotEntity*>(it->second);
     CEyeBotCircle& cController = dynamic_cast<CEyeBotCircle&>(cQuadbots.GetControllableEntity().GetController());
      
      /* Count how many foot-bots are in which state -> add here  *Old codes for reference *
      
      if(! cController.IsResting()) ++unWalkingQBs;
      else ++unRestingQBs;   
      
      /* Get the position of the foot-bot on the ground as a CVector2 -> add here */
      CVector2 cPos;
      cPos.Set(cQuadbots.GetEmbodiedEntity().GetOriginAnchor().Position.GetX(),
               cQuadbots.GetEmbodiedEntity().GetOriginAnchor().Position.GetY());
      
       
      
      
      /* Get food data -> add here*/
      
      CEyeBotCircle::SFoodData& sFoodData = cController.GetFoodData();
      
      
              /* Update each robot energy expediture due to Flying*/
      if(! cController.IsResting()) {
	
      /*sFoodData.nEnergy  = sFoodData.nEnergy  - m_unEnergyPerWalkingRobot;
      m_nEnergy = sFoodData.nEnergy;*/
      
      sFoodData.nEnergy++;
      sFoodData.rechargestates = false;
	
      }
      else {
	if (sFoodData.nEnergy == 0) {
	sFoodData.rechargestates = true;
	}
	else {sFoodData.nEnergy--;}
      }
      
      /* The foot-bot has a food item -> add here
       */
      if(sFoodData.HasFoodItem) {
         /* Check whether the foot-bot is in the nest -> add here
	  */
         if(cPos.GetX() < -1.0f) {
            /* Place a new food item on the ground -> add here */
            m_cFoodPos[sFoodData.FoodItemIdx].Set(m_pcRNG->Uniform(m_cForagingArenaSideX),
                                                  m_pcRNG->Uniform(m_cForagingArenaSideY));
            /* Drop the food item -> add here 
            sFoodData.HasFoodItem = false;
            sFoodData.FoodItemIdx = 0;
            ++sFoodData.TotalFoodItems;
            /* Increase the energy and food count -> add here
            m_nEnergy += m_unEnergyPerFoodItem;
            ++m_unCollectedFood;
            /* The floor texture must be updated -> add here
            m_pcFloor->SetChanged();
         */ }
      }
      else {
         /* The foot-bot has no food item */
         /* Check whether the foot-bot is out of the nest -> add here */
         if(cPos.GetX() > -1.0f) {
            /* Check whether the foot-bot is on a food item -> add here
            bool bDone = false;
            for(size_t i = 0; i < m_cFoodPos.size() && !bDone; ++i) {
               if((cPos - m_cFoodPos[i]).SquareLength() < m_fFoodSquareRadius) {
                  /* If so, we move that item out of sight -> add here
                  m_cFoodPos[i].Set(100.0f, 100.f);
                  /* The foot-bot is now carrying an item -> add here
                  sFoodData.HasFoodItem = true;
                  sFoodData.FoodItemIdx = i;
                  /* The floor texture must be updated -> add here
                  m_pcFloor->SetChanged();
                  /* We are done -> add here
                  bDone = true;
               }
            }*/
         }
      }
     
  }

  
   /* Update energy expediture due to walking robots *Original code for reference
 
   m_nEnergy -= unWalkingQBs * m_unEnergyPerWalkingRobot;
   
   /* Output stuff to file */
   m_cOutput << GetSpace().GetSimulationClock() << "\t"
             << unWalkingQBs << "\t"
             << unRestingQBs << "\t"
             << m_unCollectedFood << "\t"
             << m_nEnergy << std::endl;  
	     

}


/****************************************/
/****************************************/

REGISTER_LOOP_FUNCTIONS(CQuadcopterLoopFunctions, "quadcopter_loop_functions")
