#ifndef QUADCOPTER_LOOP_FUNCTIONS_H
#define QUADCOPTER_LOOP_FUNCTIONS_H

#include <argos3/core/simulator/loop_functions.h>
#include <argos3/core/simulator/entity/floor_entity.h>
#include <argos3/core/utility/math/range.h>
#include <argos3/core/utility/math/rng.h>

using namespace argos;

class CQuadcopterLoopFunctions : public CLoopFunctions {

public:
  
   
  CQuadcopterLoopFunctions();
  
     struct Trailphe {
      Real LocationX ;
      Real LocationY ;
      float phe;   
      
      Trailphe();
      void Reset();

  };/*trailphe[500];*/
  
  
   virtual ~CQuadcopterLoopFunctions() {}

   virtual void Init(TConfigurationNode& t_tree);
   virtual void Reset();
   virtual void Destroy();
   
   virtual void PreStep();
    
   virtual CColor GetFloorColor(const CVector2& c_position_on_plane);
   
   
 /* inline Trailphe& GetTrailData( Trailphe ( &trailphe )[500] ) {
     
 
  return trailphe[500];
   }*/
 
inline Trailphe& GetTrailData(){
  
  return trailphe;
}
   
Trailphe trailphe;

private:

   Real m_fFoodSquareRadius;
   Real m_CArenasizeX1,m_CArenasizeX2,m_CArenasizeY1,m_CArenasizeY2;
   CRange<Real> m_cForagingArenaSideX, m_cForagingArenaSideY,m_workingX,m_workingY ;
   
   std::vector<CVector2> m_cFoodPos;
   CFloorEntity* m_pcFloor;
   CRandom::CRNG* m_pcRNG;
   CRandom::CRNG* m_pcRNGCrashSite;

   std::string m_strOutput;
   std::ofstream m_cOutput;

   CVector2 m_CArenasizeX, m_CArenasizeY;
   UInt32 m_unCollectedFood;
   UInt32 m_nEnergy;
   UInt32 m_unEnergyPerWalkingRobot;
   Real LocationX ;
   
   
   
};

#endif
